package com.example.GPSCam;

import java.io.File;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;
import com.example.GPSCam.R;
import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.location.GpsStatus;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.media.ExifInterface;
import android.media.MediaScannerConnection;
import android.media.MediaScannerConnection.MediaScannerConnectionClient;
import android.net.Uri;
import android.os.Bundle;
import android.os.Environment;
import android.provider.MediaStore;
import android.text.format.Time;
import android.util.Log;
import android.webkit.WebView;
import android.widget.Toast;

public class GPSCam extends Activity implements LocationListener,
		MediaScannerConnectionClient, GpsStatus.Listener {

	private LocationManager locationManager;
	WebView position;
	public double lat;
	public double lng;
	public static final int OUT_OF_SERVICE = 0;
	public static final int TEMPORARILY_UNAVAILABLE = 1;
	public static final int AVAILABLE = 2;

	private static final int CAPTURE_IMAGE_ACTIVITY_REQUEST_CODE = 100;

	// directory of photos to be kept
	private File pictureDir;
	// name of result image, directory + image name
	private String fileName;
	// result image file
	private File globPictureFile = null;
	private ExifInterface exifInterface;
	private int GPSValid = 1;
	private boolean GPSEnabled = true;
	// variables for gps lat,long, and their references "N/S/E/W"
	private String latDegree, latMin, latSec, sLatR, lngDegree, lngMin, lngSec,
			sLngR;
	MediaScannerConnection msc;

	private Intent camIntent;
	String photoFile;
	Uri outputFileUri;

	private double testLat = 1.3104211678728461;
	private double testLng = 103.90087947249413;

	// private static final double =

	/** Called when the activity is first created. */

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_gpscam);
		lat = -1;
		lng = -1;
		// ///position = (WebView) findViewById(R.id.WebView);
		// ///position.getSettings().setJavaScriptEnabled(true);

		// define locationManager, in this case, the service we are interested
		// in is location service
		locationManager = (LocationManager) getSystemService(Context.LOCATION_SERVICE);

		// this line defines how frequent to update, 2nd parameter is the
		// frequency in time to update, 3rd parameter is frequency in distance
		// to update, 4th parameter is the listener
		locationManager.requestLocationUpdates(locationManager.GPS_PROVIDER, 0,
				0, this);
		GPSEnabled = this.checkGPSEnable(getApplicationContext(),
				locationManager);

		locationManager.addGpsStatusListener(this);

		this.startCamera();
	}

	/*
	 * LocationListener implements 4 methods, 1)onLocationChanged,
	 * 2)onStatusChanged, 3)onProviderEnabled ,4)onProviderDisabled This method
	 * defines the operation to be performed when a location is changed
	 */
	public void onLocationChanged(Location location) {
		lat = location.getLatitude();
		lng = location.getLongitude();
		String text = "My location is: Lat = " + lat + " Lgn = " + lng
				+ " GPSValid is: " + GPSValid;
		Log.d("GPS DATA", text);
		// Toast.makeText(getApplicationContext(), text, Toast.LENGTH_SHORT)
		// .show();

		// this is the url to display the current location on google map
		/*
		 * String url = "http://maps.google.com/staticmap?center=" + lat + "," +
		 * lng + "&zoom=18&size=512x512&maptype=mobile/&markers=" + lat + "," +
		 * lng;
		 */
		// load the URL
		// ///position.loadUrl(url);
	}

	// This method is called when status of service provider is changed such as
	// temporary unavailable to available
	public void onStatusChanged(String provider, int status, Bundle extras) {
		// TODO Auto-generated method stub
	}

	// This method is called when service provider is enabled
	public void onProviderEnabled(String provider) {
		/*
		 * Toast.makeText(this, "Enabled new provider " + provider,
		 * Toast.LENGTH_SHORT).show();
		 */
	}

	// This method is called when service provider is disabled
	public void onProviderDisabled(String provider) {
		/*
		 * Toast.makeText(this, "Disabled provider " + provider,
		 * Toast.LENGTH_SHORT).show();
		 */
	}

	public void onDestroy() {
		// finish();
		super.onDestroy();
	}

	public boolean checkGPSEnable(Context context,
			LocationManager locationManager) {
		boolean enabledGPS = locationManager
				.isProviderEnabled(LocationManager.GPS_PROVIDER);

		if (!enabledGPS) {
			Toast.makeText(getApplicationContext(), "GPS is not enabled",
					Toast.LENGTH_SHORT).show();
			GPSValid = 1;
			return false;
		} else {
			GPSValid = 0;
			return true;
		}
	}

	// convert coord to DMS format and get reference for EXIF
	protected void processCoord(double coordLat, double coordLng) {
		// get the decimal portion of coord
		double deciNum = coordLat % 1;
		// get the whole number part
		int wholeNum = (int) coordLat;

		// process latitude to dms
		// define latDegree
		latDegree = String.valueOf(wholeNum);

		// for minute, we want the decimal portion of coord * 60
		coordLat = deciNum * 60;
		// get the decimal portion
		deciNum = coordLat % 1;
		// get the whole number part
		wholeNum = (int) coordLat;

		// define latMin
		latMin = String.valueOf(wholeNum);

		// for seconds, we want the decimal portion of the minutes *60
		coordLat = deciNum * 60;
		// get the whole number portion of it
		wholeNum = (int) coordLat;

		// define latSec
		latSec = String.valueOf(wholeNum);
		// end lat deci to dms

		// process long to dms
		deciNum = coordLng % 1;
		wholeNum = (int) coordLng;

		lngDegree = String.valueOf(wholeNum);

		coordLng = deciNum * 60;
		deciNum = coordLng % 1;
		wholeNum = (int) coordLng;

		lngMin = String.valueOf(wholeNum);

		coordLng = deciNum * 60;
		wholeNum = (int) coordLng;

		lngSec = String.valueOf(wholeNum);
		// end long deci to dms

		if (coordLat < 0) {
			sLatR = "S";
		} else {
			sLatR = "N";
		}

		if (coordLng < 0) {
			sLngR = "W";
		} else {
			sLngR = "E";
		}
	}

	// save info to EXIF
	protected void saveToEXIF(File path) {

		try {
			// instantiate exifinterface
			exifInterface = new ExifInterface(path.toString());
			String fLat = "";
			String fLng = "";
			String fLatR = "";
			String fLngR = "";
			
			//values for the various EXIF interface
			fLat = latDegree + "/1," + latMin + "/1," + latSec + "/1";
			fLng = lngDegree + "/1," + lngMin + "/1," + lngSec + "/1";
			fLatR = sLatR;
			fLngR = sLngR;
			
			// set the attributes for lat long
			exifInterface.setAttribute(ExifInterface.TAG_GPS_LATITUDE, fLat);

			exifInterface.setAttribute(ExifInterface.TAG_GPS_LONGITUDE, fLng);

			exifInterface.setAttribute(ExifInterface.TAG_GPS_LATITUDE_REF,
					fLatR);

			exifInterface.setAttribute(ExifInterface.TAG_GPS_LONGITUDE_REF,
					fLngR);

			// save the attributes
			exifInterface.saveAttributes();
			// this shows how to retrive info from exif
			Log.d("EXIF DATA",
					"lat: "
							+ exifInterface
									.getAttribute(ExifInterface.TAG_GPS_LONGITUDE)
							+ " lng: "
							+ exifInterface
									.getAttribute(ExifInterface.TAG_GPS_LONGITUDE));
		} catch (IOException e) {
			Log.d("Error", e.getMessage());
			return;
		}
	}

	protected void startCamera() {
		// get the picture file to manipuate
		globPictureFile = this.setUpImageFile();

		// obtain uri
		Uri outputFileUri = Uri.fromFile(globPictureFile);
		Log.d("globpicfile in startcam",
				"globpicfile: " + globPictureFile.getPath());
		// create camera intent
		camIntent = new Intent(MediaStore.ACTION_IMAGE_CAPTURE);
		// define where to keep the photo
		camIntent.putExtra(MediaStore.EXTRA_OUTPUT, outputFileUri);

		// this method will call onActivityResult() upon finishing an activity
		// i.e. image captured
		startActivityForResult(camIntent, CAPTURE_IMAGE_ACTIVITY_REQUEST_CODE);
	}

	// this method is used to trigger media scanner to allow photos taken to be
	// read
	private void triggerMediaScanner(File pictureFile) {
		Intent mediaScanIntent = new Intent(
				Intent.ACTION_MEDIA_SCANNER_SCAN_FILE);
		File f = new File(pictureFile.getAbsolutePath());
		Uri contentUri = Uri.fromFile(f);
		mediaScanIntent.setData(contentUri);
		this.sendBroadcast(mediaScanIntent);
	}

	// this method is used to define the path of the photo taken
	protected File setUpImageFile() {
		// establish mediascanner connection
		msc = new MediaScannerConnection(this.getApplicationContext(), this);
		msc.connect();

		fileName = "";

		// determine the directory of the image depending on whether GPS signal
		// available and time of the day
		if (GPSValid == 0) {
			pictureDir = new File(Environment.getExternalStorageDirectory()
					.toString()
					+ File.separator
					+ "PotatoMemNap"
					+ File.separator + "GPSValid");
		} else if (GPSValid == 1) {
			//Create Time object
			Time now = new Time();
			//get the current time
			now.setToNow();
			//get the hour of the current time
			int hourNow = now.hour;
			if (hourNow >= 6 && hourNow <= 11) {
				// morning
				pictureDir = new File(Environment.getExternalStorageDirectory()
						.toString()
						+ File.separator
						+ "PotatoMemNap"
						+ File.separator
						+ "GPSInvalid"
						+ File.separator
						+ "Morning");
			} else if (hourNow >= 12 && hourNow <= 17) {
				// afternoon
				pictureDir = new File(Environment.getExternalStorageDirectory()
						.toString()
						+ File.separator
						+ "PotatoMemNap"
						+ File.separator
						+ "GPSInvalid"
						+ File.separator
						+ "Afternoon");
			} else if (hourNow >= 18 && hourNow <= 23) {
				// night
				pictureDir = new File(Environment.getExternalStorageDirectory()
						.toString()
						+ File.separator
						+ "PotatoMemNap"
						+ File.separator
						+ "GPSInvalid"
						+ File.separator
						+ "Night");
			} else if (hourNow >= 0 && hourNow <= 5) {
				// latenight
				pictureDir = new File(Environment.getExternalStorageDirectory()
						.toString()
						+ File.separator
						+ "PotatoMemNap"
						+ File.separator
						+ "GPSInvalid"
						+ File.separator
						+ "Late_night");
			}
		}

		// check if unable to create folder if it does not exist already
		if (!pictureDir.exists() && !pictureDir.mkdirs()) {
			Log.d("directory", "Can't create directory to save image.");
			Toast.makeText(this, "Can't create directory to save image.",
					Toast.LENGTH_LONG).show();
		}

		// construct the name of the picture taken
		SimpleDateFormat dateFormat = new SimpleDateFormat("yyyymmddhhmmss");
		String date = dateFormat.format(new Date());
		String photoFile = "Picture_" + date + ".jpg";

		// resulting name of image i.e.
		// sdcard\cameraDemo\Picture_xxxxxxxxxxxxxx.jpg
		Log.d("in setupfile check validgps", "" + GPSValid);
		fileName = pictureDir.getPath() + File.separator + photoFile;
		File pictureFile = new File(fileName);
		Log.d("in setupfile check validgps and path", "GPSvalid: " + GPSValid
				+ "  path: " + pictureFile.getPath());
		return pictureFile;
	}

	//this method obtains the distance between 2 locations from GPS
	protected float calculateGPSDistance() {
		//create the source location
		Location source = new Location("source");
		//set the lat and lng of the source, now hard coded
		source.setLatitude(this.testLat);
		source.setLongitude(this.testLng);

		//create the destination location
		Location dest = new Location("dest");
		dest.setLatitude(this.lat);
		dest.setLongitude(this.lng);

		Log.d("dist values", "slat: " + source.getLatitude() + " slng: "
				+ source.getLongitude() + " dlat: " + dest.getLatitude()
				+ " dlng: " + dest.getLongitude());

		//obtain the distance from souce to destination in meters and return the value
		return source.distanceTo(dest);
	}

	// this method is called upon completing an activity, here, take photo
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		if (requestCode == CAPTURE_IMAGE_ACTIVITY_REQUEST_CODE) {
			if (resultCode == RESULT_OK) {
				// updatePictureFile is used to move the file if GPS signal is
				// valid
				File updatePictureFile = null;

				Log.d("onactivityresult",
						"activity result  " + globPictureFile.toString());

				Toast.makeText(this, "Picture saved.", Toast.LENGTH_SHORT)
						.show();

				if (GPSValid == 0) {
					// if GPS is valid, calculate the distance from source to
					// dest to bound a radius
					if (this.calculateGPSDistance() < 10) {
						Toast.makeText(this, "at home", Toast.LENGTH_SHORT)
								.show();
						Log.d("distance", "at home");
					} else {
						Toast.makeText(this, "NOT at home", Toast.LENGTH_SHORT)
								.show();
						Log.d("distance", "NOT at home");
					}

					Toast.makeText(this,
							"Distance is: " + this.calculateGPSDistance(),
							Toast.LENGTH_SHORT).show();
					Log.d("distance", "" + this.calculateGPSDistance()
							+ "t/f: " + (this.calculateGPSDistance() < 10));

					Log.d("globPicturefile path", globPictureFile.getPath());
					updatePictureFile = new File(this.setUpImageFile()
							.getPath());

					Log.d("updatePictureFile in activityresult", ""
							+ updatePictureFile.getPath());

					globPictureFile.renameTo(updatePictureFile);

					this.triggerMediaScanner(globPictureFile);
					this.triggerMediaScanner(updatePictureFile);
				} else if (GPSValid == 1) {
					updatePictureFile = this.globPictureFile;
					this.triggerMediaScanner(globPictureFile);
					this.triggerMediaScanner(updatePictureFile);
				}
				// Log.d("distance", "" + distance[0]);
				Log.d("updatPicFile name", updatePictureFile.toString());
				// process the GPS coord
				this.processCoord(this.lat, this.lng);
				// save information to EXIF
				this.saveToEXIF(updatePictureFile);
				// trigger media scanner
				// this.triggerMediaScanner(updatePictureFile);

				finish();
			} else if (resultCode == RESULT_CANCELED) {
				Toast.makeText(this, "Picture was not taken",
						Toast.LENGTH_SHORT).show();
			} else {
				Toast.makeText(this, "Picture was not taken",
						Toast.LENGTH_SHORT).show();
			}
			// upon finish current activity, allow user to take another picture

			finish();
			startActivity(new Intent(GPSCam.this, this.getClass()));
		}
	}

	public void onMediaScannerConnected() {
		Log.d("scanner connected", "scanner connected");
	}

	public void onScanCompleted(String path, Uri uri) {
		Log.d("scanned comeplete", " scan complete");
	}

	public void onGpsStatusChanged(int event) {
		switch (event) {
		case GpsStatus.GPS_EVENT_STARTED:
			// Started
			break;
		case GpsStatus.GPS_EVENT_FIRST_FIX:
			// First Fix
			GPSValid = 0;
			Toast.makeText(getApplicationContext(),
					"Check GPS Valid listener ff: " + GPSValid,
					Toast.LENGTH_SHORT).show();
			Log.d("Check GPS Valid listener: ff", "awdwa: " + GPSValid);
			break;
		case GpsStatus.GPS_EVENT_STOPPED:
			// Stopped
			GPSValid = 1;
			Toast.makeText(getApplicationContext(),
					"Check GPS Valid listener: stop" + GPSValid,
					Toast.LENGTH_SHORT).show();
			Log.d("Check GPS Valid listener: stop", "awdwa: " + GPSValid);
			break;
		}
	}
}
